SystemOrganization addCategory: #ConfigurationOfKiwi!

Object subclass: #ConfigurationOfKiwi
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfKiwi'!

!ConfigurationOfKiwi class methodsFor: 'development support' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfKiwi class methodsFor: 'private' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfKiwi class methodsFor: 'private' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfKiwi class methodsFor: 'private' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfKiwi class methodsFor: 'metacello tool support' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfKiwi class methodsFor: 'loading' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfKiwi class methodsFor: 'loading' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfKiwi class methodsFor: 'loading' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfKiwi class methodsFor: 'accessing' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
project

	^self new project! !

!ConfigurationOfKiwi class methodsFor: 'development support' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfKiwi methodsFor: 'baselines' stamp: 'DR 6/28/2012 11:20'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/truekiwi'.
		spec 
			project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'PetitParser' with: [
				spec
					className: 'ConfigurationOfPetitParser';
					versionString: #'stable';
					repository: 'http://source.lukas-renggli.ch/petit' ].
		spec 
			package: 'Kiwi-Core' with: [ spec requires: #('PetitParser') ];
			package: 'Kiwi-Tests' with: [ spec requires: #('Mocketry' 'Core') ];
			package: 'Kiwi-Features' with: [ spec requires: #('Mocketry' 'default') ];
			package: 'Kiwi-Examples-Smalltalks2011' with: [ spec requires: #('Mocketry' 'default') ];
			package: 'Kiwi-Examples-FootballMatches' with: [ spec requires: #('Mocketry' 'default') ];
			package: 'Kiwi-Examples-PromediosAFA' with: [ spec requires: #('Mocketry' 'default') ];
			package: 'Kiwi-UI' with: [ spec requires: #('Core') ].
		spec 
			group: 'default' with: #('UI');
			group: 'Core' with: #('Kiwi-Core');
			group: 'UI' with: #('Kiwi-UI');
			group: 'Tests' with: #('Kiwi-Tests');
			group: 'Features' with: #('Kiwi-Features');
			group: 'Examples' with: #('Kiwi-Examples-Smalltalks2011' 'Kiwi-Examples-FootballMatches' 'Kiwi-Examples-PromediosAFA') ].
! !

!ConfigurationOfKiwi methodsFor: 'symbolic versions' stamp: 'NahuelGarbezza 1/13/2012 18:23'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfKiwi methodsFor: 'accessing' stamp: 'NahuelGarbezza 1/13/2012 18:18'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfKiwi methodsFor: 'versions' stamp: 'NahuelGarbezza 5/4/2012 08:44'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version
0.1 ():
0.1 ():
0.1 ():
added another example
0.1 ():'.
		spec author: 'NahuelGarbezza'.
		spec timestamp: '5/4/2012 08:44'.
		spec 
			project: 'Mocketry' with: #'stable';
			project: 'PetitParser' with: #'stable'.
		spec 
			package: 'Kiwi-Core' with: 'Kiwi-Core-NahuelGarbezza.33';
			package: 'Kiwi-Tests' with: 'Kiwi-Tests-NahuelGarbezza.22';
			package: 'Kiwi-Features' with: 'Kiwi-Features-NahuelGarbezza.11';
			package: 'Kiwi-UI' with: 'Kiwi-UI-NahuelGarbezza.18';
			package: 'Kiwi-Examples-Smalltalks2011' with: 'Kiwi-Examples-Smalltalks2011-NahuelGarbezza.1';
			package: 'Kiwi-Examples-FootballMatches' with: 'Kiwi-Examples-FootballMatches-NahuelGarbezza.1';
			package: 'Kiwi-Examples-PromediosAFA' with: 'Kiwi-Examples-PromediosAFA-NahuelGarbezza.2'. ].
! !
